<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2010 osCommerce

  Released under the GNU General Public License
*/

  class d_GOOGLE_SITEMAP {
    var $code = 'd_google_sitemap';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function d_google_sitemap() {
      $this->title = MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_TITLE;
      $this->description = MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_DESCRIPTION;

      if ( defined('MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_STATUS') ) {
        $this->sort_order = MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_SORT_ORDER;
        $this->enabled = (MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_STATUS == 'True');
      }
    }

    function getOutput() {
      $datecheck_file = DIR_FS_CATALOG . 'sitemapindex.xml';
      $date_last_checked = tep_datetime_short(date('Y-m-d H:i:s', filemtime($datecheck_file)));
	  $base_url = HTTP_SERVER . DIR_WS_CATALOG;
	  $url_gs_update = $base_url . 'googlesitemap/index.php';
  	  $url_gs_ping = 'http://www.google.com/webmasters/sitemaps/ping?sitemap=' . $base_url . 'sitemapindex.xml';
	  $url_gs_docs = $base_url . 'googlesitemap/index.html';

      $output = '<table border="0" width="100%" cellspacing="0" cellpadding="4">' .
                '  <tr class="dataTableHeadingRow">' .
                '    <td class="dataTableHeadingContent">' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_TITLE . '&nbsp;' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_LINKS .'</td>' .
                '    <td class="dataTableHeadingContent" align="right">' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_DATE . '</td>' .
                '  </tr>';
      $output .= '  <tr class="dataTableRow" onmouseover="rowOverEffect(this);" onmouseout="rowOutEffect(this);">' .
                 '    <td class="dataTableContent"><a href="' . $url_gs_update . '" target="blank">' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_UPDATE_NOW . '</a></td>' .
				 '    <td class="dataTableContent" align="right">' . $date_last_checked . '</td>' .
                 '  </tr>' .
				 '  <tr class="dataTableRow" onmouseover="rowOverEffect(this);" onmouseout="rowOutEffect(this);">' .
                 '    <td class="dataTableContent" colspan="2"><a href="' . $url_gs_ping . '" target="blank">' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_PING . '</a></td>' .
				 '  </tr>' .
				 '  <tr class="dataTableRow" onmouseover="rowOverEffect(this);" onmouseout="rowOutEffect(this);">' .
                 '    <td class="dataTableContent" colspan="2"><a href="' . $url_gs_docs . '" target="blank">' . MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_DOCS . '</a></td>' .
				 '  </tr>' .
                 '</table>';

      return $output;
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_STATUS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Google XML Sitemap Admin Module', 'MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_STATUS', 'True', 'Do you want to show the google xml sitemap module on the dashboard?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_SORT_ORDER', '1300', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_STATUS', 'MODULE_ADMIN_DASHBOARD_GOOGLE_SITEMAP_SORT_ORDER');
    }
  }
?>
