<?php
/*
  $Id: ot_codfee.php,v 1.11 2003/02/14 06:03:32 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class ot_codfee {
    var $title, $output;

    function ot_codfee() {
      $this->code = 'ot_codfee';
      $this->title = MODULE_ORDER_TOTAL_CODFEE_TITLE;
      $this->description = MODULE_ORDER_TOTAL_CODFEE_DESCRIPTION;
      $this->enabled = ((MODULE_ORDER_TOTAL_CODFEE_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_ORDER_TOTAL_CODFEE_SORT_ORDER;

      $this->output = array();
    }

    function process() {
      global $order, $currencies, $payment;

      if (MODULE_ORDER_TOTAL_CODFEE_STATUS == 'true') {        
      if ($GLOBALS['payment'] == MODULE_ORDER_TOTAL_CODFEE_PAYMENT_TYPE) { 
          $tax = tep_get_tax_rate(MODULE_ORDER_TOTAL_CODFEE_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);
          $tax_description = tep_get_tax_description(MODULE_ORDER_TOTAL_CODFEE_TAX_CLASS, $order->delivery['country']['id'], $order->delivery['zone_id']);

          $order->info['tax'] += tep_calculate_tax(MODULE_ORDER_TOTAL_CODFEE_FEE, $tax);
          $order->info['tax_groups']["$tax_description"] += tep_calculate_tax(MODULE_ORDER_TOTAL_CODFEE_FEE, $tax);
          $order->info['total'] += MODULE_ORDER_TOTAL_CODFEE_FEE + tep_calculate_tax(MODULE_ORDER_TOTAL_CODFEE_FEE, $tax);

          $this->output[] = array('title' => $this->title . ':',
                                  'text' => $currencies->format(tep_add_tax(MODULE_ORDER_TOTAL_CODFEE_FEE, $tax), true, $order->info['currency'], $order->info['currency_value']),
                                  'value' => tep_add_tax(MODULE_ORDER_TOTAL_CODFEE_FEE, $tax));
        }
      }
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_CODFEE_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_CODFEE_STATUS', 'MODULE_ORDER_TOTAL_CODFEE_SORT_ORDER', 'MODULE_ORDER_TOTAL_ALLOW_CODFEE_FEE', 'MODULE_ORDER_TOTAL_CODFEE_FEE', 'MODULE_ORDER_TOTAL_CODFEE_TAX_CLASS', 'MODULE_ORDER_TOTAL_CODFEE_PAYMENT_TYPE');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display COD Fee', 'MODULE_ORDER_TOTAL_CODFEE_STATUS', 'true', 'Do you want to display the COD fee?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_CODFEE_SORT_ORDER', '4', 'Sort order of display.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Allow COD Order Fee', 'MODULE_ORDER_TOTAL_ALLOW_CODFEE_FEE', 'true', 'Do you want to allow COD order fees?', '6', '3', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('COD Fee', 'MODULE_ORDER_TOTAL_CODFEE_FEE', '7.25', 'COD fee.', '6', '5', 'currencies->format', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_CODFEE_TAX_CLASS', '0', 'Use the following tax class on the COD fee.', '6', '7', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment type', 'MODULE_ORDER_TOTAL_CODFEE_PAYMENT_TYPE', 'cod', 'Payment Type to pay surcharge', '6', '2', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
